<?php

namespace App\Http\Controllers; 

use Validator;
use App\User;
use Firebase\JWT\JWT;
use Illuminate\Http\Request;
use Firebase\JWT\ExpiredException;
use Illuminate\Support\Facades\Hash;
use Illuminate\Pagination\Paginator;
use Laravel\Lumen\Routing\Controller as BaseController;
use Carbon\Carbon;
use DB;
// use Illuminate\Http\Request;



use App\SystemSetting;

use App\Country;
use App\BankAccount;
use App\ChildAccount;
use App\AccountType;
use App\Subject;
use App\ChartOfAccount;
use App\ChartOfAccountGroup;

use App\Imports\UsersImport;
use App\Imports\Tmain2Import;
use App\Imports\Tmain4Import;
use App\Tmain2Temp;
use App\Tmain4Temp;
use App\Imports\BankReconciliationImport;
use App\BankReconciliation;
use App\DataUpload;
use Maatwebsite\Excel\Facades\Excel;


class AccountController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public $current_user_id;
    public $current_store_mode;
    public $client_configuration;

    public function __construct(Request $request)
    {
        //

         // $token = $request->bearerToken();
        // $credentials = JWT::decode($token, env('JWT_SECRET'), ['HS256']);
       
        // $this->current_user_id =  $credentials->sub;
        $this->current_user_id =  0;
        $this->client_configuration = SystemSetting::find(1);
        
    }


 //  category ends


  

 
  
        /// Bank start
 public function getAllChartOfAccounts(){
        $countries = ChartOfAccount::All();
        $groups = ChartOfAccountGroup::All();
        if($countries){
            return response()->json([
                'status' => 'success', 'result' => $countries,'chart_of_account_group'=>$groups], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }

    public function saveChartOfAccount(Request $request)
    { 
        $name = $request->input('name');
        $description = $request->input('description');
        $account_type = $request->input('account_type');
        $code = $request->input('code');
        $chart_of_account_group = $request->input('chart_of_account_group');
        $check_existence = ChartOfAccount::where('name',$name)->where('description',$description)->where('chart_of_account_group',$chart_of_account_group)->where('account_type',$account_type)->first();
        if($check_existence){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Record Already Exist"], 200);
        }else{// save and return data
        $dataModel = new ChartOfAccount();
        $dataModel->name = $name;
        $dataModel->description = $description;
        $dataModel->code = $code;
        $dataModel->account_type = $account_type;
        $dataModel->chart_of_account_group = $chart_of_account_group;
        $dataModel->updated_at = Carbon::now();
        $dataModel->created_at = Carbon::now();
        $dataModel->save();
         if($dataModel){
            $new_record = ChartOfAccount::where('name',$name)->where('description',$description)->where('chart_of_account_group',$chart_of_account_group)->where('account_type',$account_type)->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Account Added Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Account Not Added"], 200);
        }
        }
        
    }

    public function updateChartOfAccount(Request $request)
    { 
          $name = $request->input('name');
        $description = $request->input('description');
       $code = $request->input('code');
       $chart_of_account_group = $request->input('chart_of_account_group');
       $account_type = $request->input('account_type');
        $record_id = $request->input('chart_of_account_id');
        $check_existence = ChartOfAccount::where('name',$name)->where('description',$description)->where('chart_of_account_group',$chart_of_account_group)->where('account_type',$account_type)->first();
        if($check_existence){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Record Already Exist With Details Provided"], 200);
        }else{// save and return data
        // $dataModel =  BankGroup::where('description_id',$record_id)->first();
       $dataModel = DB::table('chart_of_accounts')->where('chart_of_account_id',$record_id)->update(
            [
                'name' => $name,
             'description' => $description,
             'code' => $code,
             'account_type' => $account_type,
             'chart_of_account_group' => $chart_of_account_group,
             'updated_at' => Carbon::now(),
         ]
        );
        
         if($dataModel){
            // $new_record = Bank::where('page_id',$record_id)->first();
            $new_record= ChartOfAccount::where([
                ['chart_of_accounts.chart_of_account_id',$record_id],
            ])
            ->select("*")->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Account Updated Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Account Not Updated"], 200);
        }
        } 
        
    }

    public function deleteChartOfAccount(Request $request)
    { 
        $record_id = $request->input('chart_of_account_id');
        $dataModel = ChartOfAccount::where('chart_of_account_id',$record_id)->delete();
        if($dataModel){
            return response()->json([
                'status' => 'success', 'result' => "",'message' => "Account Deleted"], 200);
        }else{
         return response()->json([
            'status' => 'fail', 'result' => "",'message' => "Account Not Deleted"], 200);
     }
 }

 // Countries endes

  
 // Subjects endes



 // Account Types endes



 public function getdashboardData(){
        $settings = SystemSetting::find(1);
       
        $users = User::join('user_groups', 'user_groups.user_group_id', '=','users.user_group')
             ->select("*")->orderBy('users.id', 'asc')->get();
              $other_banks = DB::table('bank_reconciliations')
            ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','bank_reconciliations.parent_account')
            
            ->where('bank_reconciliations.locked','yes')
            ->where('bank_reconciliations.is_found','no')
            // ->where('bank_reconciliations.parent_account',$account_id)
            ->where('bank_accounts.account_type',2)
            ->where('bank_reconciliations.debit_amount','>',0)
            // ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")
            ->groupBy('bank_reconciliations.parent_account')
            ->get();
            $bogs = DB::table('bank_reconciliations')
            ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','bank_reconciliations.parent_account')
            ->where('bank_reconciliations.locked','yes')
            ->where('bank_reconciliations.is_found','no')
            ->where('bank_accounts.account_type',1)
            ->where('bank_reconciliations.debit_amount','>',0)
            ->groupBy('bank_reconciliations.parent_account')
            ->get();
        if($settings){
            return response()->json([
                'status' => 'success', 'settings' => $settings,'other_banks'=>$other_banks,'bogs'=>$bogs,'users'=>$users], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }
 // Account Types endes
  
}



