<?php

namespace App\Http\Controllers; 

use Validator;
use App\User;
use Firebase\JWT\JWT;
use Illuminate\Http\Request;
use Firebase\JWT\ExpiredException;
use Illuminate\Support\Facades\Hash;
use Illuminate\Pagination\Paginator;
use Laravel\Lumen\Routing\Controller as BaseController;
use Carbon\Carbon;
use DB;
// use Illuminate\Http\Request;

use App\SystemSetting;

use App\Country;
use App\BankAccount;
use App\ChildAccount;
use App\AccountType;
use App\Subject;
use App\Bank;

use App\Imports\UsersImport;
use App\Imports\Tmain2Import;
use App\Imports\Tmain4Import;
use App\Tmain2Temp;
use App\Tmain4Temp;
use App\Imports\BankReconciliationImport;
use App\BankReconciliation;
use App\DataUpload;
use Maatwebsite\Excel\Facades\Excel;

class BankController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public $current_user_id;
    public $current_store_mode;
    public $client_configuration;

    public function __construct(Request $request)
    {
        //

        //  $token = $request->bearerToken();
        // $credentials = JWT::decode($token, env('JWT_SECRET'), ['HS256']);
       
        // $this->current_user_id =  $credentials->sub;
        // $this->current_user_id =  0;
        $this->client_configuration = SystemSetting::find(1);
        
    }

    public function uploadFile(Request $request) 
    {
        $file = $_FILES['file'];
        $filePath = $file['tmp_name'];
        $file_path = $file['tmp_name'];
        $file_name = $file['name'];
        $account_id = $_POST['account_id'];
        $user_id = $_POST['user_id'];
        // $date = Date('Y-m-d H:i:s');
        $date = Date('Y-m-d');
        $upload_type = 'tmain2';
        $batch_number = $user_id."/".$account_id."/".$date;
        $dataModel = new DataUpload();
        $dataModel->parent_account = $account_id;
        $dataModel->batch_number = $batch_number;
        $dataModel->num_uploads = 1;
        $dataModel->upload_status = 'new';
        $dataModel->updated_at = Carbon::now();
        $dataModel->created_at = Carbon::now();
        $dataModel->save();

        // $cordinates = $this->getCordinateData($filePath);
        // Excel::import(new UsersImport, 'users.xlsx');
        // $array = Excel::import(new UsersImport, $file_path);
        $array = Excel::import(new BankReconciliationImport($account_id,$user_id,$batch_number,$upload_type), $file_path);
        // $array = Excel::import(new Tmain2Import($account_id,$user_id,$batch_number), $file_path);

        // $first = Tmain2Temp::where('batch_number',$batch_number)->first();
        // $dataModel = Tmain2Temp::where('tmain2_temp_id',$first->tmain2_temp_id)->delete();
        
        // $first = Tmain2Temp::where('batch_number',$batch_number)->first();
        // $all_imported_data = Tmain2Temp::where('batch_number',$batch_number)->where('tmain2_temp_id','>',$first->tmain2_temp_id)->get();
$all_imported_data = null;
        // $validate = $this->validateData($first->balance,$all_imported_data);
        $validate = null;

        // $all_imports = Tmain2Temp::where('batch_number','1/2020-09-22 14:02:16')->get();
        // $user = Excel::import(new UsersImport, $file_path);
        // $array = Excel::toArray(new UsersImport, $file_path,'');
        // return $array;
        // var_dump($all_imports);
        // return $array;
        $dataUpload = DataUpload::where('batch_number', $batch_number)->first();
        return response()->json([
                'status' => 'success', 'message'=>"Data Uploaded Successfully", 'result' => $all_imported_data,'is_error'=>$validate,'data_upload'=>$dataUpload], 200);
        // var_dump($user);
        // return redirect('/')->with('success', 'All good!');
    }

 public function uploadFile2(Request $request) 
    {
        $file = $_FILES['file'];
        $filePath = $file['tmp_name'];
        $file_path = $file['tmp_name'];
        $file_name = $file['name'];
        $account_id = $_POST['account_id'];
        $user_id = $_POST['user_id'];
        $upload_type = 'tmain4';
        // $date = Date('Y-m-d H:i:s');
        // $batch_number = $user_id."/".$date;
        $batch_number = $_POST['batch_number'];

        $array = Excel::import(new BankReconciliationImport($account_id,$user_id,$batch_number,$upload_type), $file_path);
        // $array = Excel::import(new Tmain4Import($account_id,$user_id,$batch_number), $file_path);

        
        
        // $first = BankReconciliation::where('batch_number',$batch_number)->first();
        // $all_imported_data = BankReconciliation::where('batch_number',$batch_number)->where('tmain4_temp_id','>',$first->tmain4_temp_id)->get();
         $all_imported_data = null;
        // $validate = $this->validateData($first->balance,$all_imported_data);
           $validate = null;
        
 $dataUpload = DataUpload::where('batch_number', $batch_number)->first();
          $dataModel = DB::table('data_uploads')->where('batch_number',$batch_number)->update(
            [
             'num_uploads' => $dataUpload->num_uploads + 1,
             'upload_status' => 'old',
             'updated_at' => Carbon::now(),
         ]
        );
                $dataUpload = DataUpload::where('batch_number', $batch_number)->get()->last();
        $dataUpload = DataUpload::where('parent_account', $account_id)->get()->last();
        return response()->json([
                'status' => 'success', 'message'=>"Data Uploaded Successfully", 'result' => $all_imported_data,'is_error'=>$validate,'data_upload'=>$dataUpload], 200);
        // var_dump($user);
        // return redirect('/')->with('success', 'All good!');
    }

public function validateData($initial_balance,$data){
      $new_balance = $initial_balance;
      $is_error = 'false';
      $error_number = '';
      $final_balance = 0;
      $count_num = 0;
      $credit_total = 0;
      $debit_total = 0;
      $balance_at_break ="";
      $error_array = array();
      $trans_involved = array();
  // User::where('id','<>',auth()->id())
      foreach ($data as $row) {
    # code...
        if($row->debit_amount != null && $row->post_date != null){
          $trans = $new_balance." - ".$row->debit_amount;
          $new_balance = $new_balance - $row->debit_amount;
          $debit_total = $debit_total + $row->debit_amount;
          $count_num++;
          if(floatval($new_balance) == floatval($row->balance)){
             array_push($trans_involved, $trans." = ".$new_balance."(".$count_num.")");
          }else{
            array_push($trans_involved, $trans." = ".$new_balance."(".$count_num.")");
            $is_error = 'true'.$count_num;
            array_push($error_array, $is_error);
            $error_number = $row->tmain2_temp_id;
            $balance_at_break = "break at debit new bal : ".$new_balance." record bal ".$row->balance;
            // break;
          }
          $final_balance = $row->balance;

        }else if($row->credit_amount != null && $row->post_date != null){
          $trans = $new_balance." + ".$row->credit_amount;
          $new_balance = $new_balance + $row->credit_amount;
          $count_num++;
          if(floatval($new_balance) == floatval($row->balance)){
            array_push($trans_involved, $trans." = ".$new_balance."(".$count_num.")");
          }else{
            array_push($trans_involved, $trans." = ".$new_balance."(".$count_num.")");
           $is_error = 'true'.$count_num;
           array_push($error_array, $is_error);
           $error_number = $row->tmain2_temp_id;
           $balance_at_break = "break at credit side new bal : ".$new_balance." record bal ".$row->balance;
           // break;
         }
         $final_balance = $row->balance;

         $credit_total = $credit_total + $row->credit_amount;
       }
       $this->saveDummyBankAccount($row);
     }
     $return_data = $is_error."/".$error_number."/ last bal ".$new_balance."/ final bal ".$final_balance."/count ".$count_num." / credit total : ".$credit_total." / dedit total : ".$debit_total." BALANCE AT BREAK ".$balance_at_break;
     $return_array = array('first'=>$return_data,'second'=>$error_array,'transactions'=>$trans_involved);
     return $return_array;
   }

  public function saveDummyBankAccount($record)
    { 
        $account_name = "Dummy Name ".$record->tmain4_temp_id;
        $account_number = $record->offset_account_number;
        $currency = 'GHS';
        $bank = 2;
        $account_type = 2;
        $check_existence = BankAccount::where('account_number',$account_number)->first();
        if($check_existence){// check for existence before saveing
            
        }else{// save and return data
          if( $record->offset_account_number == null){

          }else{


        $dataModel = new BankAccount();
        $dataModel->account_name = $account_name;
        $dataModel->account_number = $account_number;
        $dataModel->currency = $currency;
        $dataModel->bank = $bank;
        $dataModel->account_type = $account_type;
        $dataModel->updated_at = Carbon::now();
        $dataModel->created_at = Carbon::now();
        $dataModel->save();
      }
        
        }
        
    }
    public function reconcileData(Request $request){
      $account_id = $request->input('account_id');
      $batch_number = $request->input('batch_number');
        $child_accounts = $request->input('child_accounts');
        // $tmain2 = Tmain2Temp::where('batch_number','1/2020-09-22 16:09:58')->first();
        $tmain2 = BankReconciliation::where('parent_account',$account_id)->where('upload_type','tmain2')->where('batch_number',$batch_number)->where('locked','no')->get();
        // $first = Tmain2Temp::where('batch_number','1/2020-09-22 16:09:58')->first();
      // $new_balance = $initial_balance;
      // $is_error = 'false';
      // $error_number = '';
      // $final_balance = 0;
      // $count_num = 0;
      // $credit_total = 0;
      // $debit_total = 0;
      // $balance_at_break ="";
      $error_array = array();
      $trans_involved = array();
  // User::where('id','<>',auth()->id())
      foreach ($tmain2 as $row) {
    # code...
       // $this->reconcileWithTmailn4($batch_number,$row);
       $this->compareWithTmailn4($account_id,$batch_number,$row);
       }
     
    $dataUpload = DataUpload::where('batch_number', $batch_number)->get()->last();
        return response()->json([
                'status' => 'success', 'message'=>"Data Reconciled Successfully", 'result' => $tmain2,'data_upload'=>$dataUpload], 200);
   }

    public function reconcileData2(Request $request){
      $batch_number = $request->input('batch_number');
        $child_accounts = $request->input('child_accounts');
        // $tmain2 = Tmain2Temp::where('batch_number','1/2020-09-22 16:09:58')->first();
        $tmain2 = Tmain2Temp::where('batch_number',$batch_number)->where('locked','no')->get();
        // $first = Tmain2Temp::where('batch_number','1/2020-09-22 16:09:58')->first();
      // $new_balance = $initial_balance;
      // $is_error = 'false';
      // $error_number = '';
      // $final_balance = 0;
      // $count_num = 0;
      // $credit_total = 0;
      // $debit_total = 0;
      // $balance_at_break ="";
      $error_array = array();
      $trans_involved = array();
  // User::where('id','<>',auth()->id())
      foreach ($tmain2 as $row) {
    # code...
       $this->reconcileWithTmailn4($batch_number,$row);
       }
     
    $dataUpload = DataUpload::where('batch_number', $batch_number)->get()->last();
        return response()->json([
                'status' => 'success', 'message'=>"Data Reconciled Successfully", 'result' => $tmain2,'data_upload'=>$dataUpload], 200);
   }

  public function compareWithTmailn4($account_id,$batch_number,$record){
    // $tmain4 = Tmain4Temp::where('batch_number','1/2020-09-22 16:09:58')->first();
        // $tmain4 = BankReconciliation::where('parent_account',$account_id)->where('upload_type','tmain4')->where('batch_number',$batch_number)->where('locked','no')->get();
        $record_found = false;
        $found_record = null;


        if($record->offset_account_number != null) {// if there is an offset account number 
          $reason = null;
          $record_found = false;
          $isChildAccount = $this->is_child_account($account_id,$record->offset_account_number);
          $correspondingEntry = $this->getTmain4CorrespondingEntryWithOffset($account_id,$batch_number,$record);
         

          if($correspondingEntry && $isChildAccount){
            $record_found = true;
            $reason = "Offset Account is a child account and a corresponding entry exist for the child account";
            $found_record = $correspondingEntry;
            
          }

         

        }else{// there is no offset account number
          $correspondingEntry = $this->getTmain4CorrespondingEntryWithoutOffset($account_id,$batch_number,$record);
          if($record->debit_amount != null && $correspondingEntry ){
            $isChildAccount = $this->is_child_account($account_id,$correspondingEntry->offset_account_number);
            if($isChildAccount){
               $record_found = true;
            $reason = "There is no offset account but there is an entry in the child account statement that matches the record";
            $found_record = $correspondingEntry;
            }
           
          }else{
            $reason = null;
            $record_found = false;
          }

        }
        
  
        $this->set_reconciled_data($record_found,$record,$found_record,$reason);
       
  }

public function is_child_account($account_id,$account_number){
  $bank_account = BankAccount::where('account_number',$account_number)->first();
  if($bank_account){

  $child_account = ChildAccount::where('parent_account',$account_id)->where('child_account',$bank_account->bank_account_id)->first();
  if($child_account){
    return true;
  }else{
    return false;
  }
}else{
  return false;
}
}

public function getTmain4CorrespondingEntryWithOffset($account_id,$batch_number,$record){
   $recordFound = BankReconciliation::where('parent_account',$account_id)
   ->where('upload_type','tmain4')
   ->where('batch_number',$batch_number)
   ->where('locked','no')
   ->where('offset_account_number',$record->offset_account_number)
   ->where('post_date',$record->post_date)
   ->where('credit_amount',$record->debit_amount)->first();
   return $recordFound;
}

public function getTmain4CorrespondingEntryWithoutOffset($account_id,$batch_number,$record){
   $recordFound = BankReconciliation::where('parent_account',$account_id)
   ->where('upload_type','tmain4')
   ->where('batch_number',$batch_number)
   ->where('locked','no')
   ->where('post_date',$record->post_date)
   ->where('credit_amount',$record->debit_amount)->first();
   return $recordFound;
}



  public function set_reconciled_data($record_found,$tmain2_record,$tmain4_record,$reason){
    $found =  'no';
    $tmain4_account = null;
    
    if($record_found){
     $found = 'yes';
     if($tmain4_record != null){
       $tmain4_account = $tmain4_record->bank_reconciliation_id;
       $dataModel = DB::table('bank_reconciliations')->where('bank_reconciliation_id',$tmain4_record->bank_reconciliation_id)->update(
        [
         'locked' => 'yes',
       ]
     );

     }
   }else{
    if($tmain2_record->offset_account_number != null) {// mark as found if offset is child
     $isChildAccount = $this->is_child_account($tmain2_record->parent_account,$tmain2_record->offset_account_number);
     if($isChildAccount){
      $found =  'yes';
      $tmain4_account = null;
      $record_found = true;
      $reason = "Offset Account is a child account but no corresponding entry";

    }
  }
}
$dataModel = DB::table('bank_reconciliations')->where('bank_reconciliation_id',$tmain2_record->bank_reconciliation_id)->update(
  [
   'child_account' => $tmain4_account,
   'locked' => 'yes',
   'reconcile_details' => $reason,
   'is_found' => $found,
             // 'updated_at' => Carbon::now(),
 ]
);


$dataModel = DB::table('data_uploads')->where('batch_number',$tmain2_record->batch_number)->update(
  [
   'data_reconciled' => 'yes',
   'updated_at' => Carbon::now(),
 ]
);
                // $dataUpload = DataUpload::where('batch_number', $batch_number)->get()->last();
return true;

}
 

     
 /// Bank Account start
 public function getAllBankAccounts(){
        // $countries = BankAccount::All();
        $countries = BankAccount::join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
             ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")->get();
        if($countries){
            $all_banks = Bank::All();
            $all_account_types = AccountType::All();
            return response()->json([
                'status' => 'success', 'result' => $countries,'all_banks'=>$all_banks,'all_account_types'=>$all_account_types], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }

 public function getAccountDetails(Request $request){
     $account_id = $request->input('account_id');
        $account_number = $request->input('account_number');
        $account_details = BankAccount::join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
             ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")
             ->where('bank_accounts.bank_account_id',$account_id)->where('bank_accounts.account_number',$account_number)->first();
        
        if($account_details){
           $dataUpload = DataUpload::where('parent_account', $account_id)->get()->last();
            $all_accounts = BankAccount::join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
             ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")->get();
            // $child_accounts = ChildAccount::All();
            $child_accounts = ChildAccount::join('bank_accounts', 'bank_accounts.bank_account_id', '=','child_accounts.child_account')->where('child_accounts.parent_account',$account_id)->get();
            return response()->json([
                'status' => 'success', 'result' => $account_details,'all_accounts'=>$all_accounts,'child_accounts'=>$child_accounts,'data_upload'=>$dataUpload], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }




    public function addChildAccount(Request $request){
        $parent_account = $request->input('account_id');
        $child_accounts = $request->input('child_accounts');
        $dataModel = DB::table('child_accounts')->where('parent_account',$parent_account)->delete();
        
            foreach ($child_accounts as $row) {
            // echo $row."<br/>";
                if($parent_account == $row){

                }else{

                $dataModel = new ChildAccount();
                $dataModel->parent_account = $parent_account;
                $dataModel->child_account = $row;
                $dataModel->updated_at = Carbon::now();
                $dataModel->created_at = Carbon::now();
                $dataModel->save();
               }
            }
        
        
           $dataList = ChildAccount::join('bank_accounts', 'bank_accounts.bank_account_id', '=','child_accounts.child_account')->where('parent_account',$parent_account)->get();

        // $dataList = User::all();
           if($dataList){
            return response()->json([
                'status' => 'success', 'result' => $dataList, "message" => "Account  Updated Successfully"], 200);
        }else{
           return response()->json([
            'status' => 'fail', 'result' => "", "message" => "Could Not Update Account"], 200);
       }
   


}

    public function saveBankAccount(Request $request)
    { 
        $account_name = $request->input('account_name');
        $account_number = $request->input('account_number');
        $currency = $request->input('currency');
        $bank = $request->input('bank');
        $account_type = $request->input('account_type');
        $check_existence = BankAccount::where('account_name',$account_name)->where('account_number',$account_number)->where('currency',$currency)->where('bank',$bank)->where('account_type',$account_type)->first();
        if($check_existence){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Record Already Exist"], 200);
        }else{// save and return data
        $dataModel = new BankAccount();
        $dataModel->account_name = $account_name;
        $dataModel->account_number = $account_number;
        $dataModel->currency = $currency;
        $dataModel->bank = $bank;
        $dataModel->account_type = $account_type;
        $dataModel->updated_at = Carbon::now();
        $dataModel->created_at = Carbon::now();
        $dataModel->save();
         if($dataModel){
            $new_record = BankAccount::join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
            ->where('bank_accounts.account_name',$account_name)->where('bank_accounts.account_number',$account_number)->where('bank_accounts.currency',$currency)->where('bank_accounts.bank',$bank)->where('bank_accounts.account_type',$account_type)
             ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Account Number Added Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Account Number Not Added"], 200);
        }
        }
        
    }

    public function updateBankAccount(Request $request)
    { 
        $account_name = $request->input('account_name');
        $account_number = $request->input('account_number');
        $currency = $request->input('currency');
        $record_id = $request->input('bank_account_id');
        $bank = $request->input('bank');
        $account_type = $request->input('account_type');
        $check_existence = BankAccount::where('account_name',$account_name)->where('account_number',$account_number)->where('currency',$currency)->where('bank',$bank)->where('account_type',$account_type)->first();
        if($check_existence){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Record Already Exist With Details Provided"], 200);
        }else{// save and return data
        // $dataModel =  CountryGroup::where('description_id',$record_id)->first();
       $dataModel = DB::table('bank_accounts')->where('bank_account_id',$record_id)->where('currency',$currency)->update(
            [
                'account_name' => $account_name,
             'account_number' => $account_number,
             'currency' => $currency,
             'bank' => $bank,
             'account_type' => $account_type,
             'updated_at' => Carbon::now(),
         ]
        );
        
         if($dataModel){
            // $new_record = Country::where('page_id',$record_id)->first();
            $new_record = BankAccount::join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
            ->where('bank_accounts.bank_account_id',$record_id)
             ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")->first();

            // $new_record= BankAccount::where([
            //     ['bank_account_id',$record_id],
            // ])
            // ->select("*")->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Bank Account Updated Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Bank Account Not Updated"], 200);
        }
        } 
        
    }

    public function deleteBankAccount(Request $request)
    { 
        $record_id = $request->input('bank_account_id');
        $dataModel = BankAccount::where('bank_account_id',$record_id)->delete();
        if($dataModel){
            return response()->json([
                'status' => 'success', 'result' => "",'message' => "Bank Account Deleted"], 200);
        }else{
         return response()->json([
            'status' => 'fail', 'result' => "",'message' => "Bank Account Not Deleted"], 200);
     }
 }

 public function getAllReconcilation(){
// $categories = Tmain2Temp::distinct('category')->pluck('category');
$result = DB::table('bank_reconciliations')
            ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','bank_reconciliations.parent_account')
            ->join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
            ->where('bank_reconciliations.locked','yes')
            ->where('bank_accounts.account_type',2)
            ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name",DB::raw('count(bank_reconciliations.bank_reconciliation_id) as total_count, sum(bank_reconciliations.debit_amount) as total_debit, sum(bank_reconciliations.bank_reviewed) as total_bank_reviewed,sum(bank_reconciliations.bog_reviewed) as total_bog_reviewed'))
            ->groupBy('bank_reconciliations.parent_account')
            ->get();
            if($result){
          
            return response()->json([
                'status' => 'success','message'=>"" ,'result' => $result], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
}

 public function getAllReconcilationBog(){
// $categories = Tmain2Temp::distinct('category')->pluck('category');
$result = DB::table('bank_reconciliations')
            ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','bank_reconciliations.parent_account')
            ->join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
            ->where('bank_reconciliations.locked','yes')
            ->where('bank_accounts.account_type',1)
            ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name",DB::raw('count(bank_reconciliations.bank_reconciliation_id) as total_count, sum(bank_reconciliations.debit_amount) as total_debit, sum(bank_reconciliations.bank_reviewed) as total_bank_reviewed,sum(bank_reconciliations.bog_reviewed) as total_bog_reviewed'))
            ->groupBy('bank_reconciliations.parent_account')
            ->get();


            if($result){
          
            return response()->json([
                'status' => 'success','message'=>"" ,'result' => $result], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
}

 public function getReconciliationDetails(Request $request){
     $account_id = $request->input('account_id');
        $account_number = $request->input('account_number');
        $account_details = BankAccount::join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
             ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")
             ->where('bank_accounts.bank_account_id',$account_id)->where('bank_accounts.account_number',$account_number)->first();
        
       $result = DB::table('bank_reconciliations')
            // ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','tmain2_temps.parent_account')
            // ->join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            // ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
            ->where('bank_reconciliations.locked','yes')
            ->where('bank_reconciliations.parent_account',$account_id)
            ->where('bank_reconciliations.debit_amount','>',0)
            // ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")
            // ->groupBy('tmain2_temps.parent_account')
            ->get();
            if($result){
          
            return response()->json([
                'status' => 'success','message'=>"" ,'result' => $result,'account_details'=>$account_details], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }

 public function getUnAuthorizedReconciliationSummary(Request $request){
     $account_id = $request->input('account_id');
        $account_number = $request->input('account_number');
        $account_type = $request->input('account_type');
        $account_details = BankAccount::join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
             ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")
             ->where('bank_accounts.bank_account_id',$account_id)->where('bank_accounts.account_number',$account_number)->first();
        
            $result = DB::table('bank_reconciliations')
            ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','bank_reconciliations.parent_account')
            ->where('bank_reconciliations.locked','yes')
            ->where('bank_reconciliations.is_found','no')
            ->where('bank_reconciliations.parent_account',$account_id)
            ->where('bank_accounts.account_type',$account_type)
            ->where('bank_reconciliations.debit_amount','>',0)
            ->select('*', DB::raw('count(bank_reconciliations.bank_reconciliation_id) as total_count, sum(bank_reconciliations.debit_amount) as total_debit, sum(bank_reconciliations.bank_reviewed) as total_bank_reviewed,sum(bank_reconciliations.bog_reviewed) as total_bog_reviewed'))->groupBy('bank_reconciliations.offset_account_number')
            ->get();
            if($result){
          
            return response()->json([
                'status' => 'success','message'=>"" ,'result' => $result,'account_details'=>$account_details], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }

     public function getUnAuthorizedReconciliationDetails(Request $request){
     $account_id = $request->input('account_id');
        $account_number = $request->input('account_number');
        $offset_account = null;
        if($account_number == 0){
          $offset_account = null;
        }else{
          $offset_account = $account_number;
        }
        $account_type = $request->input('account_type');
        $account_details = BankAccount::join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
             ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")
             ->where('bank_accounts.bank_account_id',$account_id)->first();
        
       $result = DB::table('bank_reconciliations')
            // ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','tmain2_temps.parent_account')
            // ->join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            // ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
            ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','bank_reconciliations.parent_account')
            ->where('bank_reconciliations.locked','yes')
            ->where('bank_reconciliations.is_found','no')
            ->where('bank_reconciliations.parent_account',$account_id)
            ->where('bank_accounts.account_type',$account_type)
            ->where('bank_reconciliations.debit_amount','>',0)
            ->where('bank_reconciliations.offset_account_number',$offset_account)

            ->get();

            if($result){
          
            return response()->json([
                'status' => 'success','message'=>"" ,'result' => $result,'account_details'=>$account_details], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }

     public function getUnAuthorizedFlagDetails(Request $request){
     $account_id = $request->input('account_id');
        $bank_reconciliation_id = $request->input('bank_reconciliation_id');
        
       
        $account_details = BankAccount::join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
             ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")
             ->where('bank_accounts.bank_account_id',$account_id)->first();
        
       $result = DB::table('bank_reconciliations')
            // ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','tmain2_temps.parent_account')
            // ->join('banks', 'banks.bank_id', '=','bank_accounts.bank')
            // ->join('account_types', 'account_types.account_type_id', '=','bank_accounts.account_type')
            ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','bank_reconciliations.parent_account')
            ->leftjoin('bank_reconciliation_feedback', 'bank_reconciliation_feedback.bank_reconciliation', '=','bank_reconciliations.bank_reconciliation_id')
            ->where('bank_reconciliations.locked','yes')
            ->where('bank_reconciliations.is_found','no')
            ->where('bank_reconciliations.parent_account',$account_id)
            ->where('bank_reconciliations.debit_amount','>',0)
            ->where('bank_reconciliations.bank_reconciliation_id',$bank_reconciliation_id)

            ->first();

            if($result){
          
            return response()->json([
                'status' => 'success','message'=>"" ,'result' => $result,'account_details'=>$account_details], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }
 // Account Types endes
  
}



