<?php

namespace App\Http\Controllers;

use Validator;
use App\User;
use Firebase\JWT\JWT;
use Illuminate\Http\Request;
use Firebase\JWT\ExpiredException;
use Illuminate\Support\Facades\Hash;
use Laravel\Lumen\Routing\Controller as BaseController;
use Carbon\Carbon;
use DB;
// use Illuminate\Http\Request;
use App\Page;
use App\BookingBus;
use App\BookingTrip;
use App\PageGroup;
use App\UserGroup;
use App\UserGroupPermission;


class BookingController extends BaseController 
{
    /**
     * The request instance.
     *
     * @var \Illuminate\Http\Request
     */
    private $request;

    /**
     * Create a new controller instance.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return void
     */
    public function __construct(Request $request) {
        $this->request = $request;
    }

  

 /// merchant_id function start
 public function getAllBookingBuses(){
        $dataList = BookingBus::All();
        if($dataList){
            return response()->json([
                'status' => 'success', 'result' => $dataList], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }
    
    public function saveBookingBus(Request $request)
    { 
        $merchant_id = $request->input('merchant_id');
        $company_name = $request->input('company_name');
        $bus_name = $request->input('bus_name');
        $number_plate = $request->input('number_plate');
        $country_of_operation = $request->input('country_of_operation');
        $booking_status = $request->input('booking_status');
        $operation_type = $request->input('operation_type');
        $capacity = $request->input('capacity');
        $price = $request->input('price');
        $bus_type = $request->input('bus_type');
        $bank_account_details = $request->input('bank_account_details');
        $mobile_money_number = $request->input('mobile_money_number');
        $bus_picture = $request->input('bus_picture');
        $check_existence = BookingBus::where('merchant_id',$merchant_id)->where('company_name',$company_name)->where('bus_name',$bus_name)->where('number_plate',$number_plate)->first();
        if($check_existence){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Record Already Exist"], 200);
        }else{// save and return data
        $dataModel = new BookingBus();
        $dataModel->merchant_id = $merchant_id;
        $dataModel->company_name = $company_name;
        $dataModel->bus_name = $bus_name;
        $dataModel->number_plate = $number_plate;
        $dataModel->country_of_operation = $country_of_operation;
        $dataModel->booking_status = 'pending';
        $dataModel->operation_type = $operation_type;
        $dataModel->capacity = $capacity;
        $dataModel->price = $price;
        $dataModel->bus_type = $bus_type;
        $dataModel->bank_account_details = $bank_account_details;
        $dataModel->mobile_money_number = $mobile_money_number;
        $dataModel->bus_picture = $bus_picture;
        $dataModel->updated_at = Carbon::now();
        $dataModel->created_at = Carbon::now();
        $dataModel->save();
         if($dataModel){
            $new_record = BookingBus::where('merchant_id',$merchant_id)->where('company_name',$company_name)->where('bus_name',$bus_name)->where('number_plate',$number_plate)->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Bus Details Saved Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Bus Not Saved"], 200);
        }
        }
        
    }

    public function updateBookingBus(Request $request)
    { 
      $company_name = $request->input('company_name');
      $merchant_id = $request->input('merchant_id');
        $bus_name = $request->input('bus_name');
        $number_plate = $request->input('number_plate');
        $country_of_operation = $request->input('country_of_operation');
        $booking_status = $request->input('booking_status');
        $operation_type = $request->input('operation_type');
        $capacity = $request->input('capacity');
        $price = $request->input('price');
        $bus_type = $request->input('bus_type');
        $bank_account_details = $request->input('bank_account_details');
        $mobile_money_number = $request->input('mobile_money_number');
        $record_id = $request->input('booking_bus_id');
        // $check_existence = BookingBus::where('merchant_id',$merchant_id)->where('company_name',$company_name)->where('bus_name',$bus_name)->first();
        // if($check_existence){// check for existence before saveing
        //     return response()->json([
        //         'status' => 'fail', 'result' => "",'message' => "Record Already Exist With Details Provided"], 200);
        // }else{// save and return data
        // $dataModel =  PageGroup::where('merchant_id_group_id',$record_id)->first();
       $dataModel = DB::table('booking_buses')->where('booking_bus_id',$record_id)->update(
            [
             'company_name' => $company_name,
             'bus_name' => $bus_name,
             'number_plate' => $number_plate,
             'country_of_operation' => $country_of_operation,
             'booking_status' => $booking_status,
             'operation_type' => $operation_type,
             'capacity' => $capacity,
             'price' => $price,
             'bus_type' => $bus_type,
             'bank_account_details' => $bank_account_details,
             'mobile_money_number' => $mobile_money_number,
             'updated_at' => Carbon::now(),
         ]
        );
        
         if($dataModel){
            // $new_record = BookingBus::where('merchant_id_function_id',$record_id)->first();
              $new_record= BookingBus::where([
                ['booking_bus_id',$record_id],
            ])
            ->select("*")->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Bus Updated Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Bus Not Updated"], 200);
        }
        // } 
        
    }
    public function disEngageBus(Request $request)
    { 
      
        $record_id = $request->input('booking_bus_id');
        
       $dataModel = DB::table('booking_buses')->where('booking_bus_id',$record_id)->update(
            [
             
             'booking_status' => "free",
             'updated_at' => Carbon::now(),
         ]
        );
        
         if($dataModel){
            // $new_record = BookingBus::where('merchant_id_function_id',$record_id)->first();
              $new_record= BookingBus::where([
                ['booking_bus_id',$record_id],
            ])
            ->select("*")->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Bus Dis Engaged Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Bus Not Dis Engaged"], 200);
        }
        // } 
        
    }

    public function deleteBookingBus(Request $request)
    { 
        $record_id = $request->input('booking_bus_id');
        $dataModel = BookingBus::where('booking_bus_id',$record_id)->delete();
        if($dataModel){
            return response()->json([
                'status' => 'success', 'result' => "",'message' => "Bus Deleted"], 200);
        }else{
         return response()->json([
            'status' => 'fail', 'result' => "",'message' => "Bus Not Deleted"], 200);
     }
 }
 // buses function ends

 /// merchant_id function start
 public function getAllBookingTrips(){
    $dataList = BookingTrip::join('booking_buses', 'booking_buses.booking_bus_id', '=','booking_trips.booking_bus_id')
             ->select("booking_trips.*","booking_buses.company_name",'booking_buses.bus_name','booking_buses.number_plate','booking_buses.company_name','booking_buses.country_of_operation')->orderBy('booking_trips.booking_trip_id', 'asc')->get();
        
        if($dataList){
             $buses = BookingBus::All();
            return response()->json([
                'status' => 'success', 'result' => $dataList,'buses'=>$buses], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }
    
    public function saveBookingTrip(Request $request)
    { 
        $booking_bus_id = $request->input('booking_bus_id');
        $booking_status = BookingBus::where('booking_bus_id',$booking_bus_id)->first()->booking_status;
        if($booking_status == 'engaged'){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Bus has not been released for booking yet : Status ENGAGED"], 200);
        }else{// save and return data
        $booking_bus_id = $request->input('booking_bus_id');
        $capacity = $request->input('capacity');
        // $number_booked = $request->input('number_booked');
        $capacity_status = $request->input('capacity_status');
        $starting_location = $request->input('starting_location');
        $destination = $request->input('destination');
        // $operation_type1 = $request->input('operation_type1');
        $departure_date = $request->input('departure_date');
        $departure_time = $request->input('departure_time');
        $price = $request->input('price');
        $trip_status = $request->input('trip_status');
        $arrival_date = $request->input('arrival_date');
        $arrival_time = $request->input('arrival_time');
        $check_existence = BookingTrip::where('booking_bus_id',$booking_bus_id)->where('capacity',$capacity)->where('departure_date',$departure_date)->where('departure_time',$departure_time)->where('destination',$destination)->where('starting_location',$starting_location)->first();
        if($check_existence){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Record Already Exist"], 200);
        }else{// save and return data
        $dataModel = new BookingTrip();
        $dataModel->booking_bus_id = $booking_bus_id;
        $dataModel->capacity = $capacity;
        // $dataModel->number_booked = $number_booked;
        $dataModel->capacity_status = "pending";
        $dataModel->starting_location = $starting_location;
        $dataModel->destination = $destination;
        // $dataModel->operation_type1 = $operation_type1;
        $dataModel->departure_date = $departure_date;
        $dataModel->departure_time = $departure_time;
        $dataModel->price = $price;
        $dataModel->trip_status = 'loading';
        $dataModel->arrival_date = $arrival_date;
        $dataModel->arrival_time = $arrival_time;
        $dataModel->updated_at = Carbon::now();
        $dataModel->created_at = Carbon::now();
        $dataModel->save();
         if($dataModel){
            $dataModel = DB::table('booking_buses')->where('booking_bus_id',$booking_bus_id)->update(
            [
             
             'booking_status' => "engaged",
             'updated_at' => Carbon::now(),
         ]
        );
            $new_record = BookingTrip::where('booking_bus_id',$booking_bus_id)->where('capacity',$capacity)->where('departure_date',$departure_date)->where('departure_time',$departure_time)->where('destination',$destination)->where('starting_location',$starting_location)->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Bus Trip Details Saved Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Bus Trip Not Saved"], 200);
        }
        }
    }
        
    }

    public function updateBookingTrip(Request $request)
    { 
       $booking_bus_id = $request->input('booking_bus_id');
        $capacity = $request->input('capacity');
        $number_booked = $request->input('number_booked');
        $capacity_status = $request->input('capacity_status');
        $starting_location = $request->input('starting_location');
        $destination = $request->input('destination');
        // $operation_type1 = $request->input('operation_type1');
        $departure_date = $request->input('departure_date');
        $departure_time = $request->input('departure_time');
        $price = $request->input('price');
        $trip_status = $request->input('trip_status');
        $arrival_date = $request->input('arrival_date');
        $arrival_time = $request->input('arrival_time');
        $record_id = $request->input('booking_trip_id');
       $dataModel = DB::table('booking_trips')->where('booking_trip_id',$record_id)->update(
            [
             'capacity' => $capacity,
             // 'number_booked' => $number_booked,
             'capacity_status' => $capacity_status,
             'starting_location' => $starting_location,
             'destination' => $destination,
             'arrival_time' => $arrival_time,
             'departure_date' => $departure_date,
             'departure_time' => $departure_time,
             'price' => $price,
             'trip_status' => $trip_status,
             'arrival_date' => $arrival_date,
             'updated_at' => Carbon::now(),
         ]
        );
        
         if($dataModel){
              $new_record= BookingTrip::join('booking_buses', 'booking_buses.booking_bus_id', '=','booking_trips.booking_bus_id')
             ->where([
                ['booking_trip_id',$record_id],
            ])
            ->select("*")->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Bus Trip Updated Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Bus Trip Not Updated"], 200);
        }
        // } 
        
    }

    public function completeTrip(Request $request)
    { 
       $booking_trip_id = $request->input('booking_trip_id');
       $booking_bus_id = $request->input('booking_bus_id');
       
       $dataModel = DB::table('booking_trips')->where('booking_trip_id',$booking_trip_id)->update(
            [
             
             'trip_status' => "completed",
             'updated_at' => Carbon::now(),
         ]
        );
       $dataModel = DB::table('booking_buses')->where('booking_bus_id',$booking_bus_id)->update(
            [
             
             'booking_status' => "free",
             'updated_at' => Carbon::now(),
         ]
        );
        
         if($dataModel){
              $new_record= BookingTrip::join('booking_buses', 'booking_buses.booking_bus_id', '=','booking_trips.booking_bus_id')
             ->where([
                ['booking_trip_id',$booking_trip_id],
            ])
            ->select("*")->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Bus Trip Completed Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Bus Trip Not Completed"], 200);
        }
        // } 
        
    }


    public function deleteBookingTrip(Request $request)
    { 
        $record_id = $request->input('booking_trip_id');
        $dataModel = BookingTrip::where('booking_trip_id',$record_id)->delete();
        if($dataModel){
            return response()->json([
                'status' => 'success', 'result' => "",'message' => "Bus Trip Deleted"], 200);
        }else{
         return response()->json([
            'status' => 'fail', 'result' => "",'message' => "Bus Trip Not Deleted"], 200);
     }
 }
  

public function GetAvailableBusesByCountry(Request $request,$country){
    $dataList = BookingBus::where('country_of_operation',$country)->where('booking_status','engaged')->get();
    if($dataList){
        return response()->json([
            'status' => 'success', 'result' => $dataList], 200);
    }else{
      
       $pointData->save();
       return response()->json([
        'status' => 'fail', 'result' => ""], 200);
   }
}

public function GetAvailableTripByBus(Request $request,$booking_bus_id){
    $dataList = BookingTrip::where('booking_bus_id',$booking_bus_id)->where('trip_status','loading')->get();
    if($dataList){
        return response()->json([
            'status' => 'success', 'result' => $dataList], 200);
    }else{
      
       $pointData->save();
       return response()->json([
        'status' => 'fail', 'result' => ""], 200);
   }
}

}

