<?php

namespace App\Http\Controllers;

use Validator;
use App\User;
use Firebase\JWT\JWT;
use Illuminate\Http\Request;
use Firebase\JWT\ExpiredException;
use Illuminate\Support\Facades\Hash;
use Laravel\Lumen\Routing\Controller as BaseController;
use Carbon\Carbon;
use DB;
// use Illuminate\Http\Request;
use App\Page;
use App\BookingBus;
use App\BookingTrip;
use App\PageGroup;
use App\UserGroup;
use App\UserGroupPermission;
use App\SystemUser;
use App\Merchant;
use App\Customer;
use App\Point;
use App\SalesTransaction;
use App\BusinessType;
use App\PointTransaction;



class CustomerController extends BaseController 
{
    /**
     * The request instance.
     *
     * @var \Illuminate\Http\Request
     */
    private $request;

    /**
     * Create a new controller instance.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return void
     */
    public function __construct(Request $request) {
        $this->request = $request;
    }



 /// merchant_id function start
    public function getAllCustomers(){
        $dataList = Customer::All();
        if($dataList){
            return response()->json([
                'status' => 'success', 'result' => $dataList], 200);
        }else{
           return response()->json([
            'status' => 'fail', 'result' => ""], 200);
       }
   }

   public function getAllActiveCustomers(){
    $dataList = Customer::where('status','active')->get();
    if($dataList){
        return response()->json([
            'status' => 'success', 'result' => $dataList], 200);
    }else{
       return response()->json([
        'status' => 'fail', 'result' => ""], 200);
   }
}

public function getCustomerById($customer_id){
    $dataList = Customer::where('customer_id',$customer_id)->first();
    if($dataList){
        return response()->json([
            'status' => 'success', 'result' => $dataList], 200);
    }else{
       return response()->json([
        'status' => 'fail', 'result' => ""], 200);
   }
}

public function GetCustomerPoints(Request $request,$customer_id){
    $dataList = Point::where('user_type_id',$customer_id)->where('user_type','customer')->first();
    if($dataList){
        return response()->json([
            'status' => 'success', 'result' => $dataList], 200);
    }else{
       $pointData = new Point();
       $pointData->user_type = 'customer';
       $pointData->user_type_id = $customer_id;
       $pointData->point = 0.0;
       $pointData->save();
       return response()->json([
        'status' => 'fail', 'result' => ""], 200);
   }
}

public function buy(Request $request){
   $customer_id = intval($request->input('CustomerId'));
        $phone_number = $request->input('PhoneNumber');
        $secrete_code = $request->input('SecretCode');
        $amount = $request->input('Amount');

        $phone_number_exist = Merchant::where('bus_contact_no',$phone_number)->first();
        if($phone_number_exist){
          $merchant_id = $phone_number_exist->merchant_id;
          $merchant_business_type = $phone_number_exist->business_type;
          $business_type_data = BusinessType::where('business_type_id',$merchant_business_type)->first();
          $commission_percentage = $business_type_data->merchant_commission_to_business;

        $customer_code_correct = Customer::where('customer_id',$customer_id)->where('secrete_code',$secrete_code)->first();

         if($customer_code_correct){
                                
          $commission_to_business = ($commission_percentage / 100) * $amount;
          $commission_to_customer = 0.6 * $commission_to_business;
          $saleData = new SalesTransaction();
          $saleData->customer_id = $customer_id;
          $saleData->merchant_id = $merchant_id;
          $saleData->amount = $amount;
          $saleData->commission_to_customer = $commission_to_customer;
          $saleData->commission_to_business = $commission_to_business;
          $saleData->date_initiated = Carbon::now();
          $saleData->save();

          if($saleData){
              $sData = SalesTransaction::join('merchants', 'merchants.merchant_id', '=','sales_transactions.merchant_id')
  ->join('customers', 'customers.customer_id', '=','sales_transactions.customer_id')
  ->where('sale_transaction_id',$saleData->id)->first();
      
          return response()->json([
        'status' => 'success', 'result' => $sData,"msg" =>'Sale Initiated Successfully! Waiting Approval'], 200);
          }else{
            return response()->json([
        'status' => 'fail', 'result' => "",'msg'=>"Could Not Initiate Sale"], 200); 
          }

         

         }else{
             return response()->json([
        'status' => 'fail', 'result' => "",'msg'=>"Wrong Secrete Code Entered"], 200); 
         }

        }else{
           return response()->json([
        'status' => 'fail', 'result' => "",'msg'=>"Merchant Phone Number Does Not Exist"], 200); 
        }
  
    $dataList = Point::where('user_type_id',$customer_id)->where('user_type','customer')->first();
    if($dataList){
        return response()->json([
            'status' => 'success', 'result' => $dataList], 200);
    }else{
       $pointData = new Point();
       $pointData->user_type = 'customer';
       $pointData->user_type_id = $customer_id;
       $pointData->point = 0.0;
       $pointData->save();
       return response()->json([
        'status' => 'fail', 'result' => ""], 200);
   }
}

public function withdrawPoint(Request $request){
 $customer_id = intval($request->input('CustomerId'));
 $phone_number = $request->input('PhoneNumber');
 $secrete_code = $request->input('SecretCode');
 $purchase_amount = $request->input('PurchaseAmount');
 $topup_amount = $request->input('TopupAmount');
 $withdrawal_point = $request->input('WithdrawalPoint');

 $phone_number_exist = Merchant::where('bus_contact_no',$phone_number)->first();
 if($phone_number_exist){
  $merchant_id = $phone_number_exist->merchant_id;
  

  $customer_code_correct = Customer::where('customer_id',$customer_id)->where('secrete_code',$secrete_code)->first();

  if($customer_code_correct){

    $pointData = Point::where('user_type_id',$customer_id)->where('user_type','customer')->first();
     $PointNow = $pointData->point;
     $totalAmount = ($PointNow * 100) + $topup_amount;
               
    if($pointData && ($purchase_amount > $totalAmount)){
     return response()->json([
      'status' => 'fail', 'result' => "",'msg'=>"You Dont Have Enough Point And Topup Amount To Withdraw"], 200); 
   }else{

     $this->updateCustomerPointWithdrawal($customer_id,$withdrawal_point,'decrease',null);
    $saleData = new SalesTransaction();
          $saleData->customer_id = $customer_id;
          $saleData->merchant_id = $merchant_id;
          $saleData->amount = $purchase_amount;
          $saleData->transaction_approved = 'yes';
        
          $saleData->date_initiated = Carbon::now();
          $saleData->date_approved = Carbon::now();
          $saleData->save();
     return response()->json([
      'status' => 'success', 'result' => $saleData,"msg" =>'Point Withdrawn And Purchase Made Successfuly'], 200);

   }

 }else{
   return response()->json([
    'status' => 'fail', 'result' => "",'msg'=>"Wrong Secrete Code Entered"], 200); 
 }

}else{
 return response()->json([
  'status' => 'fail', 'result' => "",'msg'=>"Merchant Phone Number Does Not Exist"], 200); 
}
}


public function transferPoint(Request $request){
 $transfer_by = intval($request->input('TransferBy'));
 $phone_number = $request->input('PhoneNumber');
 $secrete_code = $request->input('SecretCode');
 $transfer_point = $request->input('Point');
 $transfer_code = $request->input('TransferCode');

 $phone_number_exist = Customer::where('phone_number',$phone_number)->first();
 if($phone_number_exist){
  $transfer_to = $phone_number_exist->customer_id;

  $customer_code_correct = Customer::where('customer_id',$transfer_by)->where('secrete_code',$secrete_code)->first();

  if($customer_code_correct){

    $pointData = Point::where('user_type_id',$transfer_by)->where('user_type','customer')->first();

    if($pointData && ($transfer_point > $pointData->point)){
     return response()->json([
      'status' => 'fail', 'result' => "",'msg'=>"Sorry You Don't have enough point to transfer"], 200); 
   }else{

     $this->updateCustomerPoint($transfer_by,$transfer_point,'decrease',null);
     $this->updateCustomerPoint($transfer_to,$transfer_point,'increase',$transfer_by);
     return response()->json([
      'status' => 'success', 'result' => "","msg" =>'Point Transfered Successfully!'], 200);

   }

 }else{
   return response()->json([
    'status' => 'fail', 'result' => "",'msg'=>"Wrong Secrete Code Entered"], 200); 
 }

}else{
 return response()->json([
  'status' => 'fail', 'result' => "",'msg'=>"Customer Phone Number Does Not Exist"], 200); 
}
}
 public function updateCustomerPointWithdrawal($customer_id,$point,$increase_decrease,$transfer_by = null){
     $pointData = Point::where('user_type_id',$customer_id)->where('user_type','customer')->first();
     if($pointData){
        
      $dataModel = DB::table('points')->where('user_type_id',$customer_id)->where('user_type','customer')->update(
            [
             'point' => ($pointData->point - $point),
             'updated_at' => Carbon::now(),
         ]
        );
      $this->addPointTransaction($customer_id,$point,$pointData->point,($pointData->point - $point),'Points withdrawn for purchase','point_withdrawal',$transfer_by);
        
     }

     }

 public function updateCustomerPoint($customer_id,$point,$increase_decrease,$transfer_by = null){
     $pointData = Point::where('user_type_id',$customer_id)->where('user_type','customer')->first();
     if($pointData){
        if($increase_decrease == 'increase'){
        $dataModel = DB::table('points')->where('user_type_id',$customer_id)->where('user_type','customer')->update(
            [
             'point' => ($point + $pointData->point),
             'updated_at' => Carbon::now(),
         ]
        );
      $this->addPointTransaction($customer_id,$point,$pointData->point,($point + $pointData->point),'Points gain from transfer','point_gain',$transfer_by);
    }else{
      $dataModel = DB::table('points')->where('user_type_id',$customer_id)->where('user_type','customer')->update(
            [
             'point' => ($pointData->point - $point),
             'updated_at' => Carbon::now(),
         ]
        );
      $this->addPointTransaction($customer_id,$point,$pointData->point,($pointData->point - $point),'Points reduce by transfer','point_transfer',$transfer_by);
    }
        
     }
     }
    

    public function addPointTransaction($customer_id,$point,$previous_point,$current_point,$reference,$transaction_type,$transfer_by = null){
       
       $pointData = new PointTransaction();
       $pointData->user_type = 'customer';
       $pointData->user_type_id = $customer_id;
       $pointData->point = $point;
       $pointData->previous_point = $previous_point;
       $pointData->current_point = $current_point;
       $pointData->reference = $reference;
       $pointData->transfer_by = $transfer_by;
       $pointData->transaction_type = $transaction_type;
       $pointData->save();
    }

public function getMySales(Request $request){

$customer_id = $request->input('customer_id');
  $dataList = SalesTransaction::join('merchants', 'merchants.merchant_id', '=','sales_transactions.merchant_id')
  ->join('customers', 'customers.customer_id', '=','sales_transactions.customer_id')
  ->where('sales_transactions.customer_id',$customer_id)
  ->where('sales_transactions.transaction_approved','yes')
  ->select("sales_transactions.*","merchants.*","customers.*")->orderBy('sales_transactions.date_initiated', 'asc')->get();
  if($dataList){
    return response()->json([
        'status' => 'success', 'result' => $dataList], 200);
}else{
   return response()->json([
    'status' => 'fail', 'result' => ""], 200);
}


}
public function getMySalesPending(Request $request){

$customer_id = $request->input('customer_id');
  $dataList = SalesTransaction::join('merchants', 'merchants.merchant_id', '=','sales_transactions.merchant_id')
  ->join('customers', 'customers.customer_id', '=','sales_transactions.customer_id')
  ->where('sales_transactions.customer_id',$customer_id)
  ->where('sales_transactions.transaction_approved','no')
  ->select("sales_transactions.*","merchants.*","customers.*")->orderBy('sales_transactions.date_initiated', 'asc')->get();
  if($dataList){
    return response()->json([
        'status' => 'success', 'result' => $dataList], 200);
}else{
   return response()->json([
    'status' => 'fail', 'result' => ""], 200);
}


}





}

