<?php

namespace App\Http\Controllers; 

use Validator;
use App\User;
use Firebase\JWT\JWT;
use Illuminate\Http\Request;
use Firebase\JWT\ExpiredException;
use Illuminate\Support\Facades\Hash;
use Illuminate\Pagination\Paginator;
use Laravel\Lumen\Routing\Controller as BaseController;
use Carbon\Carbon;
use DB;
// use Illuminate\Http\Request;



use App\SystemSetting;

use App\Country;
use App\BankAccount;
use App\ChildAccount;
use App\AccountType;
use App\Subject;
use App\Bank;
use App\ChartOfAccountGroup;

use App\Imports\UsersImport;
use App\Imports\Tmain2Import;
use App\Imports\Tmain4Import;
use App\Tmain2Temp;
use App\Tmain4Temp;
use App\Imports\BankReconciliationImport;
use App\BankReconciliation;
use App\DataUpload;
use Maatwebsite\Excel\Facades\Excel;


class LookupController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public $current_user_id;
    public $current_store_mode;
    public $client_configuration;

    public function __construct(Request $request)
    {
        //

         // $token = $request->bearerToken();
        // $credentials = JWT::decode($token, env('JWT_SECRET'), ['HS256']);
       
        // $this->current_user_id =  $credentials->sub;
        $this->current_user_id =  0;
        $this->client_configuration = SystemSetting::find(1);
        
    }


 //  category ends

public function getSystemSetting(){
        $dataList = SystemSetting::find(1);
        if($dataList){
            return response()->json([
                'status' => 'success', 'result' => $dataList], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }

  

  public function updateSystemSetting(Request $request)
    { 
         
        
        $company_name = $request->input('company_name');
        $subscriber_url = $request->input('subscriber_url');
        $pagination_length = $request->input('pagination_length');
        $company_address = $request->input('company_address');
        $currency = $request->input('currency');
        $website = $request->input('website');
        $email = $request->input('email');
        $phone_number = $request->input('phone_number');
        $return_policy = $request->input('return_policy');
        $num_receipt_print = $request->input('num_receipt_print');
        $default_background_color = $request->input('default_background_color');
       

        // $dataModel =  AdminBankGroup::where('description_id',$record_id)->first();
       $dataModel = DB::table('system_settings')->where('id',1)->update(
            [
             'company_name' => $company_name,
             'subscriber_url' => $subscriber_url,
             'pagination_length' => $pagination_length,
             'company_address' => $company_address,
             'currency' => $currency,
             'num_receipt_print' => $num_receipt_print,
             'website' => $website,
             'email' => $email,
             'default_background_color' => $default_background_color,
             'phone_number' => $phone_number,
             'return_policy' => $return_policy,
             
             'updated_at' => Carbon::now(),
         ]
        );
        
         if($dataModel){
            $new_record = SystemSetting::find(1);
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "SystemSetting Updated Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "SystemSetting Not Updated"], 200);
        }
        
         
        
    }

    public function saveClientLogo(Request $request)
    { 
        $company_logo = $request->input('company_logo');
        // $record_id = $request->input('record_id');
        // $dataModel =  AdminBankGroup::where('description_id',$record_id)->first();
       $dataModel = DB::table('system_settings')->where('id',1)->update(
            [
             'company_logo' => $company_logo,
             'updated_at' => Carbon::now(),
         ]
        );
        
         if($dataModel){
           // $new_record = User::join('user_groups', 'user_groups.user_group_id', '=','users.user_group')->where('id',$record_id)->first();
            $new_record = SystemSetting::find(1);
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Logo Uploaded Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Logo Not Updated"], 200);
        }
         
        
    }

  
        /// Bank start
 public function getAllAccountGroups(){
        $countries = ChartOfAccountGroup::All();
        if($countries){
            return response()->json([
                'status' => 'success', 'result' => $countries], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }

     public function getAllBanks(){
        $countries = Bank::All();
        if($countries){
            return response()->json([
                'status' => 'success', 'result' => $countries], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }

    public function saveBank(Request $request)
    { 
        $name = $request->input('name');
        $description = $request->input('description');
        $account_type = $request->input('account_type');
        $owner = $request->input('owner');
        $check_existence = Bank::where('name',$name)->where('description',$description)->where('owner',$owner)->where('account_type',$account_type)->first();
        if($check_existence){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Record Already Exist"], 200);
        }else{// save and return data
        $dataModel = new Bank();
        $dataModel->name = $name;
        $dataModel->description = $description;
        $dataModel->owner = $owner;
        $dataModel->account_type = $account_type;
        $dataModel->updated_at = Carbon::now();
        $dataModel->created_at = Carbon::now();
        $dataModel->save();
         if($dataModel){
            $new_record = Bank::where('name',$name)->where('description',$description)->where('owner',$owner)->where('account_type',$account_type)->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Bank Saved Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Bank Not Saved"], 200);
        }
        }
        
    }

    public function updateBank(Request $request)
    { 
          $name = $request->input('name');
        $description = $request->input('description');
       $owner = $request->input('owner');
       $account_type = $request->input('account_type');
        $record_id = $request->input('bank_id');
        $check_existence = Bank::where('name',$name)->where('description',$description)->where('owner',$owner)->where('account_type',$account_type)->first();
        if($check_existence){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Record Already Exist With Details Provided"], 200);
        }else{// save and return data
        // $dataModel =  BankGroup::where('description_id',$record_id)->first();
       $dataModel = DB::table('banks')->where('bank_id',$record_id)->update(
            [
                'name' => $name,
             'description' => $description,
             'owner' => $owner,
             'account_type' => $account_type,
             'updated_at' => Carbon::now(),
         ]
        );
        
         if($dataModel){
            // $new_record = Bank::where('page_id',$record_id)->first();
            $new_record= Bank::where([
                ['banks.bank_id',$record_id],
            ])
            ->select("*")->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Bank Updated Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Bank Not Updated"], 200);
        }
        } 
        
    }

    public function deleteBank(Request $request)
    { 
        $record_id = $request->input('bank_id');
        $dataModel = Bank::where('bank_id',$record_id)->delete();
        if($dataModel){
            return response()->json([
                'status' => 'success', 'result' => "",'message' => "Bank Deleted"], 200);
        }else{
         return response()->json([
            'status' => 'fail', 'result' => "",'message' => "Bank Not Deleted"], 200);
     }
 }

 // Countries endes

  
 // Subjects endes

   /// Accout Types start
 public function getAllAccountTypes(){
        $countries = AccountType::All();
        if($countries){
            return response()->json([
                'status' => 'success', 'result' => $countries], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }
    public function saveAccountType(Request $request)
    { 
        $name = $request->input('name');
        $description = $request->input('description');
        $check_existence = AccountType::where('name',$name)->where('description',$description)->first();
        if($check_existence){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Record Already Exist"], 200);
        }else{// save and return data
        $dataModel = new AccountType();
        $dataModel->name = $name;
        $dataModel->description = $description;
        $dataModel->updated_at = Carbon::now();
        $dataModel->created_at = Carbon::now();
        $dataModel->save();
         if($dataModel){
            $new_record = AccountType::where('name',$name)->where('description',$description)->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Account Type Saved Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Account Type Not Saved"], 200);
        }
        }
        
    }

    public function updateAccountType(Request $request)
    { 
          $name = $request->input('name');
        $description = $request->input('description');
       
        $record_id = $request->input('account_type_id');
        $check_existence = Subject::where('name',$name)->where('description',$description)->first();
        if($check_existence){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Record Already Exist With Details Provided"], 200);
        }else{// save and return data
        // $dataModel =  BankGroup::where('description_id',$record_id)->first();
       $dataModel = DB::table('account_types')->where('account_type_id',$record_id)->update(
            [
                'name' => $name,
             'description' => $description,
             'updated_at' => Carbon::now(),
         ]
        );
        
         if($dataModel){
            // $new_record = Bank::where('page_id',$record_id)->first();
            $new_record= AccountType::where([
                ['account_type_id',$record_id],
            ])
            ->select("*")->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Account Type Updated Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Account Type Not Updated"], 200);
        }
        } 
        
    }

    public function deleteAccountType(Request $request)
    { 
        $record_id = $request->input('account_type_id');
        $dataModel = AccountType::where('account_type_id',$record_id)->delete();
        if($dataModel){
            return response()->json([
                'status' => 'success', 'result' => "",'message' => "Account Type Deleted"], 200);
        }else{
         return response()->json([
            'status' => 'fail', 'result' => "",'message' => "Account Type Not Deleted"], 200);
     }
 }

 // Account Types endes



 public function getdashboardData(){
        $settings = SystemSetting::find(1);
       
        $users = User::join('user_groups', 'user_groups.user_group_id', '=','users.user_group')
             ->select("*")->orderBy('users.id', 'asc')->get();
              $other_banks = DB::table('bank_reconciliations')
            ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','bank_reconciliations.parent_account')
            
            ->where('bank_reconciliations.locked','yes')
            ->where('bank_reconciliations.is_found','no')
            // ->where('bank_reconciliations.parent_account',$account_id)
            ->where('bank_accounts.account_type',2)
            ->where('bank_reconciliations.debit_amount','>',0)
            // ->select("bank_accounts.*","banks.name as bank_name","account_types.name as account_type_name")
            ->groupBy('bank_reconciliations.parent_account')
            ->get();
            $bogs = DB::table('bank_reconciliations')
            ->join('bank_accounts', 'bank_accounts.bank_account_id', '=','bank_reconciliations.parent_account')
            ->where('bank_reconciliations.locked','yes')
            ->where('bank_reconciliations.is_found','no')
            ->where('bank_accounts.account_type',1)
            ->where('bank_reconciliations.debit_amount','>',0)
            ->groupBy('bank_reconciliations.parent_account')
            ->get();
        if($settings){
            return response()->json([
                'status' => 'success', 'settings' => $settings,'other_banks'=>$other_banks,'bogs'=>$bogs,'users'=>$users], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }
 // Account Types endes
  
}



