<?php

namespace App\Http\Controllers;

use Validator;
use App\User;
use Firebase\JWT\JWT;
use Illuminate\Http\Request;
use Firebase\JWT\ExpiredException;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Str;
use Laravel\Lumen\Routing\Controller as BaseController;
use Carbon\Carbon;
use DB;
use Illuminate\Support\Facades\Storage;
// use Illuminate\Http\Request;
use App\Page;
use App\Product;
use App\BookingTrip;
use App\PageGroup;
use App\UserGroup;
use App\UserGroupPermission;
use App\SystemUser;
use App\Merchant;
use App\Customer;
use App\Point;
use App\PointTransaction;
use App\MerchantService;
use App\ServiceImage;
use App\SalesTransaction;
use App\BusinessType;
use App\Advert;
use App\SpecialOffer;

class MobileSpecialOfferController extends BaseController 
{
    /**
     * The request instance.
     *
     * @var \Illuminate\Http\Request
     */
    private $request;

    /**
     * Create a new controller instance.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return void
     */
    public function __construct(Request $request) {
        $this->request = $request;
    }
    
  
 
 public function getAllSpecialOffersByMerchant(Request $request){
        $merchant_id = $request->input('merchant_id');
        // $dataList = SpecialOffer::leftJoin
        // ->where('merchant_id',$merchant_id)->get();

        $dataList = SpecialOffer::leftjoin('merchant_services', 'merchant_services.service_id', '=','special_offers.merchant_service_id')
             ->select("special_offers.*","merchant_services.name as product_name")
             ->where('special_offers.merchant_id',$merchant_id)
             ->get();

        if($dataList){
            return response()->json([
                'status' => 'success', 'result' => $dataList], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => ""], 200);
        }
    }

     public function storeImage64($image_64){
      // $image_64 = $data['photo']; //your base64 encoded data
  $extension = explode('/', explode(':', substr($image_64, 0, strpos($image_64, ';')))[1])[1];   // .jpg .png .pdf
  $replace = substr($image_64, 0, strpos($image_64, ',')+1); 
// find substring fro replace here eg: data:image/png;base64,
 $image = str_replace($replace, '', $image_64); 
 $image = str_replace(' ', '+', $image); 
 $imageName = Str::random(10).'.'.$extension;
 Storage::disk('public')->put($imageName, base64_decode($image));
  return $imageName;
    }

public function saveSpecialOffer(Request $request)
    { 
        $merchant_id = $request->input('merchant_id');
        $merchant_service_id = $request->input('merchant_service_id');
        $description = $request->input('description');
        $target_audience = $request->input('target_audience');
        $age_range = $request->input('age_range');
        $country = $request->input('country');
  $image_64 = $request->input('file'); //your base64 encoded data
  $image_base = $request->input('image_base'); 
        
        $check_existence = SpecialOffer::where('merchant_id',$merchant_id)->where('description',$description)->where('target_audience',$target_audience)->where('age_range',$age_range)->first();
        if($check_existence){// check for existence before saveing
            return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Record Already Exist"], 200);
        }else{// save and return data

        if($image_64 == ''){
            $imageName = "";
        }else{
            $imageName = $this->storeImage64($image_64);
        }
        

        $dataModel = new SpecialOffer();
        $dataModel->merchant_id = $merchant_id;
        $dataModel->merchant_service_id = $merchant_service_id;
        $dataModel->description = $description;
        $dataModel->target_audience = $target_audience;
        $dataModel->age_range = $age_range;
         if($image_64 != ''){
        $dataModel->image_link = $image_base."app/public/".$imageName;
    }
        $dataModel->country = $country;
        $dataModel->updated_at = Carbon::now();
        $dataModel->created_at = Carbon::now();
        $dataModel->save();
         if($dataModel){
            $new_record = SpecialOffer::where('merchant_id',$merchant_id)->where('description',$description)->where('target_audience',$target_audience)->where('age_range',$age_range)->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "SpecialOffer Added Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Special Offer Not Added"], 200);
        }
        }
        
    }

  public function updateSpecialOffer(Request $request)
    { 
      $special_offer_id = $request->input('special_offer_id');
      $description = $request->input('description');
      $merchant_id = $request->input('merchant_id');
       $merchant_service_id = $request->input('merchant_service_id');
        $target_audience = $request->input('target_audience');
        $age_range = $request->input('age_range');
        $country = $request->input('country');
        $image_64 = $request->input('file'); //your base64 encoded data
  $image_base = $request->input('image_base'); 
  if($image_64 == ''){
            $imageName = "";
        }else{
            $imageName = $this->storeImage64($image_64);
        }
        if($image_64 == ''){
 $dataModel = DB::table('special_offers')->where('special_offer_id',$special_offer_id)->update(
            [
             'description' => $description,
             'target_audience' => $target_audience,
             'merchant_service_id' => $merchant_service_id,
             'age_range' => $age_range,
             'country' => $country,
             'updated_at' => Carbon::now(),
         ]
        );
             }else{
 $dataModel = DB::table('special_offers')->where('special_offer_id',$special_offer_id)->update(
            [
             'description' => $description,
             'target_audience' => $target_audience,
             'merchant_service_id' => $merchant_service_id,
             'age_range' => $age_range,
             'country' => $country,
             'image_link' => $image_base."app/public/".$imageName,
             'updated_at' => Carbon::now(),
         ]
        );
             }
      
        
         if($dataModel){
            // $new_record = SpecialOffer::where('merchant_id_function_id',$record_id)->first();
              $new_record= SpecialOffer::where([
                ['special_offer_id',$special_offer_id],
            ])
            ->select("*")->first();
            return response()->json([
                'status' => 'success', 'result' => $new_record,'message' => "Special Offer Updated Successfully"], 200);
        }else{
             return response()->json([
                'status' => 'fail', 'result' => "",'message' => "Special Offer Not Updated"], 200);
        }
        // } 
        
    }
  
public function deleteSpecialOffer(Request $request)
    { 
        $record_id = $request->input('special_offer_id');
        $dataModel = SpecialOffer::where('special_offer_id',$record_id)->delete();
        if($dataModel){
            return response()->json([
                'status' => 'success', 'result' => "",'message' => "Special Offer Deleted"], 200);
        }else{
         return response()->json([
            'status' => 'fail', 'result' => "",'message' => "SpecialOffer Not Deleted"], 200);
     }
 }


}

