<?php

namespace App\Imports;

use App\BankReconciliation;
use Maatwebsite\Excel\Concerns\ToModel;
use Maatwebsite\Excel\Concerns\WithHeadingRow;
use Maatwebsite\Excel\Concerns\WithBatchInserts;
use Maatwebsite\Excel\Concerns\WithStartRow;

class BankReconciliationImport implements ToModel, WithBatchInserts,WithStartRow
{
  public $parent_account;
  public $user_id;
  public $batch_number;
  public $upload_type;
  public function  __construct($parent_account,$user_id,$batch_number,$upload_type) {
    $this->parent_account = $parent_account;
    $this->user_id = $user_id;
    $this->batch_number = $batch_number;
    $this->upload_type = $upload_type;
}
    /**
    * @param array $row
    *
    * @return \Illuminate\Database\Eloquent\Model|null
    */
    public function startRow(): int
    {
        return 2;
    }
    public function model(array $row)
    {
        // if (!isset($row[0])) {
        //     return null;
        // }else{
        // date('Y-m-d', 1198148400); // echos 2014-01-0
      if($row[0] != null){

        return new BankReconciliation([
         'parent_account'  => $this->parent_account,
         'user_id' => $this->user_id,
         'batch_number' => $this->batch_number,
         'upload_type' => $this->upload_type,
         'post_date'    => $this->formatDateExcel($row[0]),
         'particulars'    => $row[1],
         'reference'    => $row[2],
         'value_date'    => $this->formatDateExcel($row[3]),
         'debit_amount'    => $row[4],
         'credit_amount'    => $row[5],
         'balance'    => $row[6],
         'offset_account_number'    => $row[7],
     ]);
    }

    }

    public function batchSize(): int
    {
        return 500;
    }

    protected function formatDateExcel($date){ 
        // if (gettype($date) === 'double')  {
           $birthday = \PhpOffice\PhpSpreadsheet\Shared\Date::excelToDateTimeObject(intval($date));
           return $birthday->format('n/j/Y'); 
       // }
       // return $date; 
   }
  
}
 // 'parent_account','post_date','batch_number','user_id','particulars','reference','value_date','debit_amount','credit_amount','balance','offset_account_number'