<?php

/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It is a breeze. Simply tell Lumen the URIs it should respond to
| and give it the Closure to call when that URI is requested.
|
*/

$router->get('/', function () use ($router) {
    return $router->app->version();
});
$router->post(
    'auth/login', 
    [
       'uses' => 'AuthController@authenticate'
    ]
);

$router->group(
    ['middleware' => 'jwt.auth'], 
    function() use ($router) {
        $router->get('users', function() {
            $users = \App\User::all();
            return response()->json($users);
        });
    }
);
// permissions begins

    // page groups
$router->get('getAllPageGroups',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@getAllPageGroups']);
$router->post('savePageGroup',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@savePageGroup']);
$router->post('updatePageGroup',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@updatePageGroup']);
$router->post('deletePageGroup',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@deletePageGroup']);
     //pages
$router->get('getAllPages',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@getAllPages']);
$router->post('savePage',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@savePage']);
$router->post('updatePage',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@updatePage']);
$router->post('deletePage',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@deletePage']);
	// page Functions
$router->get('getAllPageFunctions',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@getAllPageFunctions']);
$router->get('getAllPageFunctionsJoinOthers',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@getAllPageFunctionsJoinOthers']);
$router->post('savePageFunction',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@savePageFunction']);
$router->post('updatePageFunction',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@updatePageFunction']);
$router->post('deletePageFunction',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@deletePageFunction']);
	// user group
$router->get('getAllUserGroups',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@getAllUserGroups']);
$router->post('getThisUserGroupPermissions',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@getThisUserGroupPermissions']);
$router->post('saveUserGroup',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@saveUserGroup']);
$router->post('saveUserGroupPermissions',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@saveUserGroupPermissions']);
$router->post('updateUserGroup',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@updateUserGroup']);
$router->post('deleteUserGroup',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@deleteUserGroup']);
    // user
$router->get('getAllUsers',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@getAllUsers']);
$router->post('saveUser',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@saveUser']);
$router->post('saveUserImage',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@saveUserImage']);
$router->post('updateUser',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@updateUser']);
$router->post('updateUserProfile',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@updateUserProfile']);
$router->post('deleteUser',  ['middleware' => 'jwt.auth','uses' => 'PermissionController@deleteUser']);
   
// permission ends
$router->get('getSystemSetting',  ['uses' => 'LookupController@getSystemSetting']);
$router->post('updateSystemSetting',  ['middleware' => 'jwt.auth','uses' => 'LookupController@updateSystemSetting']);
$router->post('saveClientLogo',  ['uses' => 'LookupController@saveClientLogo']);



     //country
$router->get('getAllBanks',  ['middleware' => 'jwt.auth','uses' => 'LookupController@getAllBanks']);
$router->post('saveBank',  ['middleware' => 'jwt.auth','uses' => 'LookupController@saveBank']);
$router->post('updateBank',  ['middleware' => 'jwt.auth','uses' => 'LookupController@updateBank']);
$router->post('deleteBank',  ['middleware' => 'jwt.auth','uses' => 'LookupController@deleteBank']);

    //country
$router->get('getAllAccountGroups',  ['middleware' => 'jwt.auth','uses' => 'LookupController@getAllAccountGroups']);
$router->post('saveAccountGroup',  ['middleware' => 'jwt.auth','uses' => 'LookupController@saveAccountGroup']);
$router->post('updateAccountGroup',  ['middleware' => 'jwt.auth','uses' => 'LookupController@updateAccountGroup']);
$router->post('deleteAccountGroup',  ['middleware' => 'jwt.auth','uses' => 'LookupController@deleteAccountGroup']);

    //subjects
$router->get('getAllChartOfAccounts',  ['middleware' => 'jwt.auth','uses' => 'AccountController@getAllChartOfAccounts']);
$router->post('saveChartOfAccount',  ['middleware' => 'jwt.auth','uses' => 'AccountController@saveChartOfAccount']);
$router->post('updateChartOfAccount',  ['middleware' => 'jwt.auth','uses' => 'AccountController@updateChartOfAccount']);
$router->post('deleteChartOfAccount',  ['middleware' => 'jwt.auth','uses' => 'AccountController@deleteChartOfAccount']);

    //account types
$router->get('getAllAccountTypes',  ['middleware' => 'jwt.auth','uses' => 'LookupController@getAllAccountTypes']);
$router->post('saveAccountType',  ['middleware' => 'jwt.auth','uses' => 'LookupController@saveAccountType']);
$router->post('updateAccountType',  ['middleware' => 'jwt.auth','uses' => 'LookupController@updateAccountType']);
$router->post('deleteAccountType',  ['middleware' => 'jwt.auth','uses' => 'LookupController@deleteAccountType']);

    // qualification types
$router->get('getAllBankAccounts',  ['middleware' => 'jwt.auth','uses' => 'BankController@getAllBankAccounts']);
$router->post('saveBankAccount',  ['middleware' => 'jwt.auth','uses' => 'BankController@saveBankAccount']);
$router->post('updateBankAccount',  ['middleware' => 'jwt.auth','uses' => 'BankController@updateBankAccount']);
$router->post('deleteBankAccount',  ['middleware' => 'jwt.auth','uses' => 'BankController@deleteBankAccount']);
$router->post('getAccountDetails',  ['middleware' => 'jwt.auth','uses' => 'BankController@getAccountDetails']);
$router->post('addChildAccount',  ['middleware' => 'jwt.auth','uses' => 'BankController@addChildAccount']);
$router->post('uploadFile',  ['middleware' => 'jwt.auth','uses' => 'BankController@uploadFile']);
$router->post('uploadFile2',  ['middleware' => 'jwt.auth','uses' => 'BankController@uploadFile2']);
$router->post('reconcileData',  ['middleware' => 'jwt.auth','uses' => 'BankController@reconcileData']);
$router->post('getUnAuthorizedReconciliationSummary',  ['middleware' => 'jwt.auth','uses' => 'BankController@getUnAuthorizedReconciliationSummary']);
$router->post('getUnAuthorizedReconciliationDetails',  ['middleware' => 'jwt.auth','uses' => 'BankController@getUnAuthorizedReconciliationDetails']);
$router->post('getUnAuthorizedFlagDetails',  ['middleware' => 'jwt.auth','uses' => 'BankController@getUnAuthorizedFlagDetails']);
$router->post('getAllReconcilation',  ['middleware' => 'jwt.auth','uses' => 'BankController@getAllReconcilation']);
$router->post('getAllReconcilationBog',  ['middleware' => 'jwt.auth','uses' => 'BankController@getAllReconcilationBog']);
$router->post('getReconciliationDetails',  ['middleware' => 'jwt.auth','uses' => 'BankController@getReconciliationDetails']);
$router->get('getDashboardData',  ['uses' => 'LookupController@getdashboardData']);
// mobile api
$router->group(['prefix' => 'mobile-api'], function () use ($router) {
  $router->post('signUpCustomer', ['uses' => 'AuthController@SignUpCustomer']);
  $router->post('SignUpMerchant', ['uses' => 'AuthController@SignUpMerchant']);
  $router->post('signin', ['uses' => 'AuthController@signin']);

  $router->get('getAllCustomers', ['uses' => 'CustomerController@getAllCustomers']);
  $router->post('buy', ['uses' => 'CustomerController@buy']);
  $router->post('transferPoint', ['uses' => 'CustomerController@transferPoint']);
  $router->post('withdrawPoint', ['uses' => 'CustomerController@withdrawPoint']);
  $router->get('getAllActiveCustomers', ['uses' => 'CustomerController@getAllActiveCustomers']);
  $router->get('getBusinessTypes', ['uses' => 'LookupController@getBusinessTypes']);
  $router->get('getCustomerById/{customer_id}', ['uses' => 'CustomerController@getCustomerById']);
  $router->post('getMySales', ['uses' => 'CustomerController@getMySales']);
  $router->post('getMySalesPending', ['uses' => 'CustomerController@getMySalesPending']);
  $router->get('GetCustomerPoints/{customer_id}', ['uses' => 'CustomerController@getCustomerPoints']);
  $router->get('getAllMerchantServices', ['uses' => 'MerchantController@getAllMerchantServices']);
  $router->get('getAllActiveMerchants', ['uses' => 'MerchantController@getAllActiveMerchants']);
  $router->post('approveSale', ['uses' => 'MerchantController@approveSale']);
  $router->post('UpdateDeviceId', ['uses' => 'LookupController@UpdateDeviceId']);

$router->get('GetAvailableBusesByBank/{country}', ['uses' => 'BookingController@GetAvailableBusesByBank']);
$router->get('GetAvailableTripByBus/{booking_bus_id}', ['uses' => 'BookingController@GetAvailableTripByBus']);

   //product / services
$router->post('getAllProducts',  ['uses' => 'MerchantController@getAllProducts']);
$router->post('getAllProductsByMerchant',  ['uses' => 'MerchantController@getAllProductsByMerchant']);
$router->post('saveProduct',  ['uses' => 'MerchantController@saveProduct']);
$router->post('updateProduct',  ['uses' => 'MerchantController@updateProduct']);
$router->post('deleteProduct',  ['uses' => 'MerchantController@deleteProduct']);

// adverts
$router->post('getAllAdvertsByMerchant',  ['uses' => 'MobileAdvertController@getAllAdvertsByMerchant']);
$router->post('saveAdvert',  ['uses' => 'MobileAdvertController@saveAdvert']);
$router->post('updateAdvert',  ['uses' => 'MobileAdvertController@updateAdvert']);
$router->post('deleteAdvert',  ['uses' => 'MobileAdvertController@deleteAdvert']);

// special offers
$router->post('getAllSpecialOffersByMerchant',  ['uses' => 'MobileSpecialOfferController@getAllSpecialOffersByMerchant']);
$router->post('saveSpecialOffer',  ['uses' => 'MobileSpecialOfferController@saveSpecialOffer']);
$router->post('updateSpecialOffer',  ['uses' => 'MobileSpecialOfferController@updateSpecialOffer']);
$router->post('deleteSpecialOffer',  ['uses' => 'MobileSpecialOfferController@deleteSpecialOffer']);

$router->post('getMerchantApprovedSales', ['uses' => 'MerchantController@getMerchantApprovedSales']);
$router->post('getMerchantSalesPending', ['uses' => 'MerchantController@getMerchantSalesPending']);
});